<template>
	<a-drawer
		:title="formData.id ? '编辑企业客户种类价格表' : '增加企业客户种类价格表'"
		:width="600"
		:visible="visible"
		:destroy-on-close="true"
		:footer-style="{ textAlign: 'right' }"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="企业客户：" name="depotId">
				<a-input v-if="formData.id" v-model:value="formData.depotGrainName" disabled/>
				<a-select v-else v-model:value="formData.depotId" placeholder="请选择客户" :options="depotIdOptions"/>
			</a-form-item>
			<a-form-item label="粮食种类：" name="grainGroup">
				<a-input v-if="formData.id" v-model:value="formData.grainGroup" disabled/>
				<a-select v-else v-model:value="formData.grainGroup" placeholder="请选择粮食种类" :options="grainGroupOptions"/>
			</a-form-item>
			<a-form-item label="默认干粮价格(元/吨)：" name="dryPrice">
				<a-input-number v-model:value="formData.dryPrice" placeholder="请输入价格" :min="0.01" style="width:100%" allow-clear/>
			</a-form-item>
			<a-form-item label="质押价格(元/吨)：" name="loanPrice">
				<a-input-number v-model:value="formData.loanPrice" placeholder="请输入价格" :min="0.01" style="width:100%" allow-clear/>
			</a-form-item>
			<a-form-item label="质押率(%)：" name="loanRatio">
				<a-input-number v-model:value="formData.loanRatio" placeholder="请输入质押率" :min="0.01" style="width:100%" allow-clear/>
			</a-form-item>
			<a-form-item label="潮干比：" name="dampRatio">
				<a-select v-model:value="formData.dampRatio" :options="dampRatioOptions"/>
			</a-form-item>
			<a-form-item label="干粮水份(%)：" name="canonRatio">
				<a-select v-model:value="formData.canonRatio" :options="canonRatioOptions"/>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</a-drawer>
</template>

<script setup name="depotGrainInfoPriceForm">
import tool from '@/utils/tool'
import {cloneDeep} from 'lodash-es'
import {required, rules} from '@/utils/formRules'
import depotGrainInfoPriceApi from '@/api/biz/depotGrainInfoPriceApi'
import dictOptionsApi from "@/api/biz/dictOptionsApi";
import {message} from "ant-design-vue";
// 抽屉状态
const visible = ref(false)
const emit = defineEmits({successful: null})
const formRef = ref()
// 表单数据
const formData = ref({})
const submitLoading = ref(false)
const depotIdOptions = ref([])
const grainGroupOptions = ref([])

// 打开抽屉
const onOpen = (record) => {
	visible.value = true
	if (record) {
		let recordData = cloneDeep(record)
		formData.value = Object.assign({}, recordData)
	} else {
		dictOptionsApi.options(Object.assign('', {'dictValue': '粮库'})).then((data) => {
			depotIdOptions.value = data
		})
	}
	grainGroupOptions.value = tool.dictList('粮食种类')
}
// 关闭抽屉
const onClose = () => {
	formRef.value.resetFields()
	formData.value = {}
	visible.value = false
}
// 默认要校验的
const formRules = {
	depotId: [required('请输入')],
	grainGroup: [required('请输入')],
	dryPrice: [required('请输入'), rules.amountCheck],
	loanPrice: [required('请输入'), rules.amountCheck],
	loanRatio: [required('请输入')],
	dampRatio: [required('请输入')],
	canonRatio: [required('请输入')],
}
// 验证并提交数据
const onSubmit = () => {
	formRef.value
		.validate()
		.then(() => {
			const formDataParam = cloneDeep(formData.value)
			if (formDataParam.loanRatio < 1 || formDataParam.loanRatio > 100) {
				message.warning('请输入质押率(%)范围 1~100 的值。')
				return false
			}
			submitLoading.value = true
			depotGrainInfoPriceApi
				.depotGrainInfoPriceSubmitForm(formDataParam, !formDataParam.id)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
}
const dampRatioOptions = tool.dictList('干粮折比')
const canonRatioOptions = tool.dictList('干粮水份')
// 抛出函数
defineExpose({
	onOpen
})
</script>
